CON
  mode          = %00001000
  baud          = 115_200
VAR

OBJ
  lcd   :       "fullduplexserial"
PUB Start(tx, rx)
  lcd.start(rx, tx, mode, baud)
  clear

PUB Clear
  lcd.str(string("clear"))
  lcd.str(string(";"))
  return

PUB Print(text, x, y)
  lcd.str(string("print "))
  lcd.str(text)
  lcd.dec(x)
  lcd.dec(y)
  lcd.str(string(";"))
  return
    
PUB Line(x1, y1, x2, y2)
  lcd.str(string("line "))
  lcd.dec(x1)
  lcd.str(string(", "))
  lcd.dec(y1)
  lcd.str(string(", "))
  lcd.dec(x2)
  lcd.str(string(", "))
  lcd.dec(y2)
  lcd.str(string(";"))
  return

PUB Box(x1, y1, x2, y2)
  lcd.str(string("box "))
  lcd.dec(x1)
  lcd.str(string(", "))
  lcd.dec(y1)
  lcd.str(string(", "))
  lcd.dec(x2)
  lcd.str(string(", "))
  lcd.dec(y2)
  lcd.str(string(";"))
  return

PUB Button(id, x1, y1, x2, y2, caption)
  lcd.str(string("button "))
  lcd.dec(id)
  lcd.dec(x1)
  lcd.str(string(", "))
  lcd.dec(y1)
  lcd.str(string(", "))
  lcd.dec(x2)
  lcd.str(string(", "))
  lcd.dec(y2)
  lcd.str(caption)
  lcd.str(string(";"))
  return

PUB Slider(xy, id, x1, y1, x2, y2, maxrange)
  case xy
    "x":
      lcd.str(string("xslider "))
      lcd.dec(id)
      lcd.dec(x1)
      lcd.str(string(", "))
      lcd.dec(y1)
      lcd.str(string(", "))
      lcd.dec(x2)
      lcd.str(string(", "))
      lcd.dec(y2)
      lcd.dec(maxrange)
      lcd.str(string(";"))
      return
    "y":
      lcd.str(string("yslider "))
      lcd.dec(id)
      lcd.dec(x1)
      lcd.str(string(", "))
      lcd.dec(y1)
      lcd.str(string(", "))
      lcd.dec(x2)
      lcd.str(string(", "))
      lcd.dec(y2)
      lcd.dec(maxrange)
      lcd.str(string(";"))
      return
      
PUB GetButton(id) : _button
  lcd.str(string("getcrtl "))
  lcd.dec(id)
  lcd.str(string("$on_click"))
  lcd.str(string(";"))
  _button := lcd.rx
  return
  
PUB GetSlider(id): _slider
  lcd.str(string("getctrl "))
  lcd.dec(id)
  lcd.str(string("$on_position"))
  lcd.str(string(";"))
  _slider := lcd.rx
  return
   
PRI Pause(ms) | clkcycles, milisec
  waitcnt(clkfreq / 1000 * ms + cnt)
  return